<?php
  include_once("functions.php");

  class DataAccess
  {
  
    static public function getAllMaps()
    {
      $sql = "SELECT * FROM `". DB_TABLE_NAME ."` ORDER BY Date ASC, ID DESC";
      $rs = mysql_query($sql);

      $maps = array();
      while($r = mysql_fetch_assoc($rs))
      {
        $map = new Map();
        $map->LoadFromArray($r);
        $maps[] = $map;
      }
      
      return $maps;
    }

    
    static public function getMaps($startDate, $endDate)
    {
      $startDateString = date("Y-m-d", $startDate);
      $endDateString = date("Y-m-d", $endDate);
      $sql = "SELECT * FROM `". DB_TABLE_NAME ."` WHERE DATE(Date)>='$startDateString' AND DATE(Date)<='$endDateString' ORDER BY Date DESC, ID DESC";
      $rs = mysql_query($sql);

      $maps = array();
      while($r = mysql_fetch_assoc($rs))
      {
        $map = new Map();
        $map->LoadFromArray($r);
        $maps[] = $map;
      }
      
      return $maps;
    }

    static public function getYears()
    {
      $sql = "SELECT DISTINCT YEAR(Date) AS Year FROM `". DB_TABLE_NAME ."` ORDER BY Date ASC";
      $rs = mysql_query($sql);
      
      $years = array();
      while($r = mysql_fetch_assoc($rs))
      {
        $years[] = $r["Year"];
      }
      return $years;
    }
    
    static public function getLastChangedTime()
    {
      $sql = "SELECT MAX(LastChangedTime) as LastChangedTime FROM `". DB_TABLE_NAME ."`";
      $r = mysql_fetch_assoc(mysql_query($sql));
      return strtotime($r["LastChangedTime"]);
    }
    
    static public function getPreviousMap($date)
    {
      $sql = "SELECT * FROM `". DB_TABLE_NAME ."` WHERE Date<'". date("Y-m-d H:i:s", $date) ."' ORDER BY Date DESC, ID DESC";
      if($r = mysql_fetch_assoc(mysql_query($sql)))
      {
        $map = new Map();
        $map->LoadFromArray($r);
        return $map;
      }
      return null;
    }

    static public function getNextMap($date)
    {
      $sql = "SELECT * FROM `". DB_TABLE_NAME ."` WHERE Date>'". date("Y-m-d H:i:s", $date) ."' ORDER BY Date ASC, ID ASC";
      $r = mysql_fetch_assoc(mysql_query($sql));
      if($r = mysql_fetch_assoc(mysql_query($sql)))
      {
        $map = new Map();
        $map->LoadFromArray($r);
        return $map;
      }
      return null;
    }
    
    static public function deleteMap($map)
    {
      $uploadDir = getRootUrl(false) . MAP_IMAGE_PATH ."/";
      self::deleteMapImage($map);
      self::deleteThumbnailImage($map);
      $map->Delete();
    }
    
    static public function saveMapAndThumbnailImage($map)
    {
      $id = $map->ID;
      $uploadDir = getRootUrl(false) . MAP_IMAGE_PATH ."/";
      
      if($_FILES['mapImage']['name'])
      {
        // map image
        $extension = getExtension($_FILES['mapImage']['name']);
        $uploadFileName = $uploadDir . $id . "." . $extension;
        self::deleteMapImage($map);
        
        chmod($uploadDir, 0777);
        if (!move_uploaded_file($_FILES['mapImage']['tmp_name'], $uploadFileName)) 
        {
            die("The map image file could not be uploaded.");
        }
        $map->MapImage = "$id.$extension";
        if(!$_FILES['thumbnailImage']['name'])
        {
          // autc-create thumbnail
          self::deleteThumbnailImage($map);
          $thumbnailImageName = createThumbnail(MAP_IMAGE_PATH ."/$id.$extension", MAP_IMAGE_PATH. "/$id.thumbnail", THUMBNAIL_WIDTH, THUMBNAIL_HEIGHT, THUMBNAIL_SCALE);
          $map->ThumbnailImage = basename($thumbnailImageName);
        }
      }
      
      if($_FILES['thumbnailImage']['name'])
      {
        // custom thumbnail image
        $extension = getExtension($_FILES['thumbnailImage']['name']);
        $uploadFileName = $uploadDir . $id . ".thumbnail." . $extension;
        self::deleteThumbnailImage($map);
        
        chmod($uploadDir, 0777);
        if (!move_uploaded_file($_FILES['thumbnailImage']['tmp_name'], $uploadFileName)) 
        {
            die("The thumbnail image file could not be uploaded.");
        }
        $map->ThumbnailImage = "$id.thumbnail.$extension";
      }
      $map->Save();
    }
    
    static public function saveMap(Map $map, $mapImageData, $mapImageFileExtension)
    {
      $isNewMap = !($map->ID);

      $tmpId = rand(0,100000);
      $tmpMapImageName = MAP_IMAGE_PATH ."/tmp_map_$tmpId.$mapImageFileExtension";
      $tmpThumbnailImageNameWithoutExtension = MAP_IMAGE_PATH. "/tmp_thumbnail_$tmpId";

      // save map image on disk
      $fp = fopen($tmpMapImageName, "w");
      fwrite($fp, $mapImageData);
      fclose($fp); 
      
      // create thumbnail image on disk
      $tmpThumbnailImageName = createThumbnail(
        $tmpMapImageName,
        $tmpThumbnailImageNameWithoutExtension,
        THUMBNAIL_WIDTH, THUMBNAIL_HEIGHT, THUMBNAIL_SCALE);

      // save map to get an id
      $map->Save();
      // save map images with file names containing this id
      $map->MapImage = $map->ID . "." . $mapImageFileExtension;
      $map->ThumbnailImage = getFilenameWithoutExtension(basename($map->MapImage)) . ".thumbnail." . getExtension($tmpThumbnailImageName);
      
      // re-save images
      copy($tmpMapImageName, MAP_IMAGE_PATH ."/". $map->MapImage);
      copy($tmpThumbnailImageName, MAP_IMAGE_PATH ."/". $map->ThumbnailImage);
      unlink($tmpMapImageName);
      unlink($tmpThumbnailImageName);
      
      // need to save the MapImage and ThumbnailImage in database
      $map->Save();
      
      if($isNewMap)
      {
        @file(DOMA_SERVER ."?id=". $map->ID);
      }
    }
    
    static public function deleteMapImage($map)
    {
      $uploadDir = getRootUrl(false) . MAP_IMAGE_PATH ."/";
      if($map->MapImage) @unlink($uploadDir . $map->MapImage);
    }

    static public function deleteThumbnailImage($map)
    {
      $uploadDir = getRootUrl(false) . MAP_IMAGE_PATH ."/";
      if($map->ThumbnailImage) @unlink($uploadDir . $map->ThumbnailImage);
    }
  }
  
?>